theory Container_Setup
imports 
  "$AFP/Abstract-Rewriting/SN_Order_Carrier"
  Linear_Polynomial
  Real_Impl
  Linear_Orders
  Forbidden_Patterns
  Tree_Automata
  "$AFP/Containers/Containers" 
begin

(* term, etc *)
derive (eq) ceq pos
derive corder pos
derive (rbt) set_impl pos
derive (no) cenum pos

instantiation pos :: finite_UNIV
begin
definition "finite_UNIV = Phantom(pos) False"
instance
  by (intro_classes, unfold finite_UNIV_pos_def, simp)
end

instantiation pos :: cproper_interval
begin
definition "cproper_interval = (\<lambda> ( _ :: pos option) _ . False)"
instance by (intro_classes, auto)
end

derive (eq) ceq "term"
derive (linorder) corder "term"
derive (rbt) set_impl "term"
derive (no) cenum "term"

derive (eq) ceq lab
derive (linorder) corder lab
derive (rbt) set_impl lab
derive (no) cenum lab

instantiation lab :: (type,type)card_UNIV
begin
definition "card_UNIV = Phantom(('a,'b)lab) 0"
definition "finite_UNIV = Phantom(('a,'b)lab) False"
instance
  by (intro_classes, auto simp: finite_UNIV_lab_def card_UNIV_lab_def infinite_lab)
end


instantiation lab :: (linorder,linorder)cproper_interval
begin
definition "cproper_interval = (\<lambda> ( _ :: ('a,'b)lab option) _ . False)"
instance by (intro_classes, auto simp: infinite_lab)
end

derive (eq) ceq mctxt
derive linorder mctxt
derive (linorder) corder mctxt
derive (rbt) set_impl mctxt
derive (no) cenum mctxt


derive (eq) ceq ctxt
derive corder ctxt
derive (rbt) set_impl ctxt
derive (no) cenum ctxt

derive (eq) ceq gctxt
derive (linorder) corder gctxt
derive (rbt) set_impl gctxt
derive (no) cenum gctxt

derive (eq) ceq location
derive corder location
derive (dlist) set_impl location
derive (no) cenum location

(* rat *)

derive (eq) ceq rat
derive (no) cenum rat
derive (linorder) corder rat
derive (rbt) set_impl rat

(* real numbers *)

derive (eq) ceq real
derive (linorder) corder real 
derive (rbt) set_impl real
derive (no) cenum real

(* l_poly *)
derive (eq) ceq l_poly
derive corder l_poly
derive (rbt) set_impl l_poly
derive (no) cenum l_poly

(* arctic and arctic_rat *)

derive (eq) ceq arctic
derive corder arctic
derive (rbt) set_impl arctic
derive (no) cenum arctic

derive (eq) ceq arctic_delta
derive corder arctic_delta
derive (rbt) set_impl arctic_delta
derive (no) cenum arctic_delta

(* tree automata *)

derive (eq) ceq ta_rule
derive linorder ta_rule
derive (linorder) corder ta_rule
derive (no) cenum ta_rule
derive (rbt) set_impl ta_rule

instantiation ta_rule :: (type,type)finite_UNIV
begin
definition "finite_UNIV = Phantom(('a,'b)ta_rule) False"
instance
  by (intro_classes, unfold finite_UNIV_ta_rule_def, simp)
end

instantiation ta_rule :: (linorder,linorder)cproper_interval
begin
definition "cproper_interval = (\<lambda> ( _ :: ('a,'b)ta_rule option) _ . False)"
instance by (intro_classes, auto)
end

text {* code equation to handle @{term Union} *}
lemma un_foldr[code_unfold]: "\<Union> (set xs) = foldr (op \<union>) xs {}"
  by (induct xs, auto)

end
