(*
Copyright 2009-2013 Christian Sternagel, René Thiemann

This file is part of IsaFoR/CeTA.

IsaFoR/CeTA is free software: you can redistribute it and/or modify it under the
terms of the GNU Lesser General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later
version.

IsaFoR/CeTA is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along
with IsaFoR/CeTA. If not, see <http://www.gnu.org/licenses/>.
*)
theory Outermost_Rewriting
imports
  Trs
  Context_Substitution
  "~~/src/HOL/Library/Monad_Syntax"
begin

definition ostep_cond_single :: "('f,'v)term \<Rightarrow> pos \<Rightarrow> ('f,'v)term \<Rightarrow> bool"
  where "ostep_cond_single l p t \<equiv> \<forall> q < p. \<not> (\<exists> \<sigma>. t |_ q = l \<cdot> \<sigma>)"

definition ostep_cond :: "('f,'v)terms \<Rightarrow> pos \<Rightarrow> ('f,'v)term \<Rightarrow> bool"
  where "ostep_cond Q p t \<equiv> \<forall> l \<in> Q. ostep_cond_single l p t"

definition ostep_p :: "('f,'v)terms \<Rightarrow> ('f,'v)trs \<Rightarrow> pos \<Rightarrow> ('f,'v)trs" 
  where "ostep_p Q R p \<equiv> {(s,t). (\<exists> lr \<sigma>. (s,t) \<in> rstep_r_p_s R lr p \<sigma>) \<and> ostep_cond Q p s}"

definition ostep :: "('f,'v)terms \<Rightarrow> ('f,'v)trs \<Rightarrow> ('f,'v)trs"
  where "ostep Q R \<equiv> {(s,t). \<exists> p. (s,t) \<in> ostep_p Q R p}"

lemmas ostep_defs = ostep_def ostep_p_def

lemma ostep_pI: "(s,t) \<in> rstep_r_p_s R lr p \<sigma> \<Longrightarrow> ostep_cond Q p s \<Longrightarrow> (s,t) \<in> ostep_p Q R p" 
  unfolding ostep_defs by blast

lemma ostep_pE[elim]: "(s,t) \<in> ostep_p Q R p \<Longrightarrow> \<lbrakk>\<And> \<sigma> lr. (s,t) \<in> rstep_r_p_s R lr p \<sigma> \<Longrightarrow> ostep_cond Q p s \<Longrightarrow> P\<rbrakk> \<Longrightarrow> P"
  unfolding ostep_defs by blast

lemma ostep_mono: assumes R: "R \<subseteq> R'" 
  shows "ostep Q R \<subseteq> ostep Q R'"
  unfolding ostep_defs rstep_r_p_s_def Let_def using R by blast

end

